local COMBAT_EVENTS = {
	["SWING_DAMAGE"] = "DAMAGE",
	["RANGE_DAMAGE"] = "DAMAGE",
	["SPELL_DAMAGE"] = "DAMAGE",
	["SPELL_PERIODIC_DAMAGE"] = "DAMAGE",
	["ENVIRONMENTAL_DAMAGE"] = "DAMAGE",
	["DAMAGE_SHIELD"] = "DAMAGE",
	["DAMAGE_SPLIT"] = "DAMAGE",
	["SPELL_HEAL"] = "HEAL",
	["SPELL_PERIODIC_HEAL"] = "HEAL",
	["SWING_MISSED"] = "MISS",
	["RANGE_MISSED"] = "MISS",
	["SPELL_MISSED"] = "MISS",
	["SPELL_PERIODIC_MISSED"] = "MISS",
	["DAMAGE_SHIELD_MISSED"] = "MISS",
	["SPELL_DRAIN"] = "DRAIN",
	["SPELL_LEECH"] = "DRAIN",
	["SPELL_PERIODIC_DRAIN"] = "DRAIN",
	["SPELL_PERIODIC_LEECH"] = "DRAIN",
	["SPELL_ENERGIZE"] = "POWER",
	["SPELL_PERIODIC_ENERGIZE"] = "POWER",
	["SPELL_INTERRUPT"] = "INTERRUPT",
	["PARTY_KILL"] = "DEATH",
	["UNIT_DIED"] = "DEATH",
	["UNIT_DESTROYED"] = "DEATH",
	["SPELL_AURA_REFRESH"] = "BUFF",
	["SPELL_AURA_APPLIED"] = "BUFF",
	["SPELL_PERIODIC_AURA_REFRESH"] = "BUFF",
	["SPELL_PERIODIC_AURA_APPLIED"] = "BUFF",
	["SPELL_AURA_APPLIED_DOSE"] = "BUFF",
	["SPELL_PERIODIC_AURA_APPLIED_DOSE"] = "BUFF",
	["SPELL_AURA_REMOVED"] = "FADE",
	["SPELL_PERIODIC_AURA_REMOVED"] = "FADE",
	["SPELL_AURA_REMOVED_DOSE"] = "FADE",
	["SPELL_PERIODIC_AURA_REMOVED_DOSE"] = "FADE",
	["ENCHANT_APPLIED"] = "ENCHANT_APPLIED",
	["ENCHANT_REMOVED"] = "ENCHANT_REMOVED",
	["SPELL_SUMMON"] = "SUMMON",
	["SPELL_CREATE"] = "SUMMON",
	["SPELL_CAST_SUCCESS"] = "SUCCESS",
	["SPELL_CAST_START"] = "SPELLSTART",
}

function pootpoot:ParsePaladinCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	local etype = COMBAT_EVENTS[event]
	local healtot, healamt, parent
	local amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing
	local spellId, spellName, spellSchool, missType, powerType, extraAmount, environmentalType, extraSpellId, extraSpellName, extraSpellSchool, auraType, overHeal
	local text, texture, message, inout, color

	if not self.db.profile.enabled then
		return
	end

	if zoneenable == false then
		return
	end

  	if not etype then
  		return
  	end

	local fromPlayer, fromPet
	if (sourceName and not CombatLog_Object_IsA(sourceFlags, COMBATLOG_OBJECT_NONE) ) then
		fromPlayer = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE)
	end
	if (destName and not CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_NONE) ) then
		toPlayer = CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MINE)
		toTarget = CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_TARGET)
	end

	--if not from player or pet, then end
	if fromPlayer then
		if etype == "DAMAGE" then
			if event == "SWING_DAMAGE" then
				amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
			else
				spellId, spellName, spellSchool, amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
			text = tostring(amount)
			if event == "SPELL_DAMAGE" then
				if spellName == "Judgement of Righteousness" then
					if (self.db.profile.judgementofrighteousnesstgl) then
						if (self.db.profile.judgementofrighteousnesscrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.judgementofrighteousnesschance*100)) then
									self:DispPootMsg( self.db.profile.judgementofrighteousness, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.judgementofrighteousnesschance*100)) then
							self:DispPootMsg( self.db.profile.judgementofrighteousness, "SAY" )
						end
					end
				elseif spellName == "Judgement of Command" then
					if (self.db.profile.judgementofcommandtgl) then
						if (self.db.profile.judgementofcommandcrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.judgementofcommandchance*100)) then
									self:DispPootMsg( self.db.profile.judgementofcommand, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.judgementofcommandchance*100)) then
							self:DispPootMsg( self.db.profile.judgementofcommand, "SAY" )
						end
					end
				elseif spellName == "Crusader Strike" then
					if (self.db.profile.crusaderstriketgl) then
						if (self.db.profile.crusaderstrikecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.crusaderstrikechance*100)) then
									self:DispPootMsg( self.db.profile.crusaderstrike, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.crusaderstrikechance*100)) then
							self:DispPootMsg( self.db.profile.crusaderstrike, "SAY" )
						end
					end
				end
			end
		elseif etype == "SUCCESS" then
			if event == "SPELL_CAST_SUCCESS" then
				spellId, spellName, spellSchool = select(1, ...)
				if spellName == "Consecration" then
					if (self.db.profile.consecrationtgl) then
						if (math.random(100) <= (self.db.profile.consecrationchance*100)) then
							self:DispPootMsg( self.db.profile.consecration, "SAY" )
						end
					end
				elseif spellName == "Beacon of Light" then
					if (self.db.profile.beaconoflighttgl) then
						if (math.random(100) <= (self.db.profile.beaconoflightchance*100)) then
							self:DispPootMsg( self.db.profile.beaconoflight, "SAY" )
						end
					end
				elseif spellName == "Hammer of the Righteous" then
					if (self.db.profile.hammeroftherighteoustgl) then
						if (math.random(100) <= (self.db.profile.hammeroftherighteouschance*100)) then
							self:DispPootMsg( self.db.profile.hammeroftherighteous, "SAY" )
						end
					end
				elseif spellName == "Divine Storm" then
					if (self.db.profile.divinestormtgl) then
						if (math.random(100) <= (self.db.profile.divinestormchance*100)) then
							self:DispPootMsg( self.db.profile.divinestorm, "SAY" )
						end
					end
				end
			end
		--elseif etype == "INTERRUPT" then
		--	if event == "SPELL_INTERRUPT" then
		--		if (self.db.profile.interrupttgl) then
		--			spellId, spellName, spellSchool, extraSpellID, extraSpellName, extraSpellSchool = select(1, ...)
		--			if string.find(extraSpellName, "[hH]eal") or string.find(extraSpellName, "[rR]egrowth") or extraSpellName == "Flash of Light" or extraSpellName == "Holy Light" or extraSpellName == "Eternal Affection" then
		--				if (math.random(100) <= (self.db.profile.interruptchance*100)) then
		--					self:DispPootMsg( self.db.profile.interrupt, "SAY" )
		--				end
		--			end
		--		end
		--	end
		elseif etype == "MISS" then
			if event == "SPELL_MISSED" then
				spellId, spellName, spellSchool, missType, amountMissed  = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
				--if spellName == "Taunt" then
				--	if (self.db.profile.tauntresisttgl) and not (missType == "IMMUNE") and not (missType == "EVADE") then
				--		self:DispPootMsg( self.db.profile.tauntresist, "SAY" )
				--	end
				--end
			end
		elseif etype == "SPELLSTART" then
			if event == "SPELL_CAST_START" then
				spellId, spellName, spellSchool = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
				if spellName == "Summon Charger" then
					if (self.db.profile.summonchargertgl) then
						if (math.random(100) <= (self.db.profile.summonchargerchance*100)) then
							self:DispPootMsg( self.db.profile.summoncharger, "SAY" )
						end
					end
				end
			end
		elseif etype == "BUFF" then
			if event == "SPELL_AURA_APPLIED" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
		if etype == "POWER" then
			--if event == "SPELL_ENERGIZE" then
			--	spellId, spellName, spellSchool, amount, powerType = select(1, ...)
			--	texture = select(3, GetSpellInfo(spellId))
			--end
		end
	elseif toPlayer then
		if etype == "BUFF" then
			if event == "SPELL_AURA_REFRESH" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
	end
	if fromPlayer and toTarget then
		if destName then -- REDUNDANT?
			if event == "SPELL_AURA_APPLIED" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
	end
end